import { ArrowBack, ArrowForward } from '@mui/icons-material';
import React from 'react';
import ReactJSONView from 'react-json-view';

type Props = {
  selected: any[];
};

export default function SelectedMenu({ selected }: Props) {
  const [exploreEntities, setExploreEntities] = React.useState<boolean>(false);

  return (
    <div>
      {selected.length > 0 && !exploreEntities && (
        <div className="bg-light p-2.5 cursor-pointer absolute top-0 right-0 hover:bg-secondary" onClick={() => setExploreEntities(true)}>
          <ArrowBack />
        </div>
      )}

      {selected.length > 0 && exploreEntities && (
        <div className="absolute flex justify-between items-start z-10 top-0 right-0">
          <div className="flex flex-col">
            <div className="bg-light p-2.5 cursor-pointer hover:bg-secondary" onClick={() => setExploreEntities(false)}>
              <ArrowForward />
            </div>
          </div>
          <div className="p-3 bg-light max-h-52 overflow-y-auto min-w-[100px] min-h-[18px]">
            <ReactJSONView
              src={selected}
              name={'Selected'}
              indentWidth={2}
              enableClipboard={false}
              collapsed={true}
              quotesOnKeys={false}
              displayDataTypes={false}
            />
          </div>
        </div>
      )}
    </div>
  );
}
